from django.shortcuts import render, get_object_or_404, redirect
from django.contrib.auth.decorators import login_required
from django.utils.crypto import get_random_string
from django.contrib import messages


#
# def index(request):
#     user = request.user
#     return render(request, "chat/index.html", context={})
#
# def detail(request):
#     user = request.user
#     return render(request, "chat/detail.html", context={})
#
# def create_new_conversation():
#     # Generate a unique room ID
#     Conversation_id = get_random_string(length=10)
#
#     # Create a new room
#     room = Conversation.objects.create(Conversation_id=Conversation_id)
#
#     # Create a new conversation associated with the room
#     conversation = Conversation.objects.create(room=room)
#
#     return conversation
#
#
# def conversation(request):
#     return render(request, 'chat/room.html')
#
# @login_required
# def conversation_list(request):
#     conversations = request.user.conversations.all()
#     return render(request, 'chat/conversation_list.html', {'conversations': conversations})
#
# @login_required
# def conversation_detail(request, conversation_id):
#     conversation = get_object_or_404(Conversation, id=conversation_id)
#     messages = conversation.message_set.order_by('timestamp')
#     return render(request, 'chat/conversation_detail.html', {'conversation': conversation, 'messages': messages})
#
# @login_required
# def send_message(request, conversation_id):
#     conversation = get_object_or_404(Conversation, id=conversation_id)
#     if request.method == 'POST':
#         sender = request.user
#         text = request.POST.get('message_text')
#         Message.objects.create(conversation=conversation, sender=sender, text=text)
#     return redirect('conversation_detail', conversation_id=conversation_id)
#

from cgi import print_arguments
from django.shortcuts import render, redirect
from .models import ChatMessage, Profile
from .forms import ChatMessageForm
from django.http import JsonResponse
import json


# Create your views here.
@login_required
def index(request):
    try:
        user = request.user.profile
    except:
        user = request.user
        # Create a new room
        room = Profile.objects.create(user_id=user.id, name=user.username, pic="")
        room.friends.set('1')
        room.save()
        user = request.user.profile

    friends = user.friends.all()
    context = {"user": user, "friends": friends}
    return render(request, "chat/index.html", context)


@login_required
def detail(request, pk):
    # friend = Friend.objects.get(profile_id=pk)
    user = request.user.profile
    profile = Profile.objects.get(user_id=pk)
    chats = ChatMessage.objects.all()
    rec_chats = ChatMessage.objects.filter(msg_sender=profile, msg_receiver=user, seen=False)
    rec_chats.update(seen=True)
    form = ChatMessageForm()
    if request.method == "POST":
        form = ChatMessageForm(request.POST)
        if form.is_valid():
            chat_message = form.save(commit=False)
            chat_message.msg_sender = user
            chat_message.msg_receiver = profile
            chat_message.save()
            return redirect("detail", pk=profile.id)
    context = {"friend": profile, "form": form, "user": user,
               "profile": profile, "chats": chats, "num": rec_chats.count()}
    return render(request, "chat/detail.html", context)


@login_required
def sentMessages(request, pk):
    user = request.user.profile
    # friend = Friend.objects.get(profile_id=pk)
    profile = Profile.objects.get(id=pk)
    data = json.loads(request.body)
    new_chat = data["msg"]
    new_chat_message = ChatMessage.objects.create(body=new_chat, msg_sender=user, msg_receiver=profile, seen=False)
    return JsonResponse(new_chat_message.body, safe=False)


@login_required
def receivedMessages(request, pk):
    user = request.user.profile
    # friend = Friend.objects.get(profile_id=pk)
    profile = Profile.objects.get(id=pk)
    arr = []
    chats = ChatMessage.objects.filter(msg_sender=profile, msg_receiver=user)
    for chat in chats:
        arr.append(chat.body)
    return JsonResponse(arr, safe=False)


@login_required
def chatNotification(request):
    user = request.user.profile
    friends = user.friends.all()
    arr = []
    for friend in friends:
        chats = ChatMessage.objects.filter(msg_sender__id=friend.profile.id, msg_receiver=user, seen=False)
        arr.append(chats.count())
    return JsonResponse(arr, safe=False)


@login_required
def AddProfile(request):
    # Generate a unique room ID
    # Conversation_id = get_random_string(length=10)

    user = request.user
    # Create a new room
    room = Profile.objects.create(user_id=user.id, name=user.username,pic="")
    room.friends.set('2')
    room.save()
    return index


@login_required
def AddUserUpdateProfile(request,sel_pk):

    if Profile.objects.filter(user_id=sel_pk):
        user = request.user
        edit_profile_self = Profile.objects.get(user_id=user.id)
        edit_profile_self.friends.add(sel_pk)
        edit_profile_self.save()

        edit_profile_next = Profile.objects.get(user_id=sel_pk)
        edit_profile_next.friends.add(user.id)
        edit_profile_next.save()

        return redirect('detail',sel_pk)
    else:
        messages.info(request, 'User profile is not activated for messages!')
        return redirect('index')



def RemoveUserUpdateProfile(request, sel_pk):
    user = request.user
    edit_profile_self = Profile.objects.get(user_id=user.id)
    edit_profile_self.friends.remove(sel_pk)
    edit_profile_self.save()
    return redirect('index')
